from src.export.strategies.export import export
from src.models.abstract_reference import abstract_reference


class markdown_export(export):
    """Класс стратегии для экспорта в Markdown"""

    def export_header(self, model: abstract_reference):
        """
            Создать заголовок экспорта
        Args:
            model (abstract_reference): модель, по которой нужно построить заголовок
        """
        res = "| "
        keys = super().get_properties(model).keys()
        res += " | ".join(keys)
        res += " |\n| "
        for key in range(len(keys)):
            res += "- |"
        return res

    def export_model(self, model: abstract_reference):
        """
            Экспортировать модель
        Args:
            model (abstract_reference): модель, строку с которой нужно создать
        """
        res = "|"
        properties = super().get_properties(model)
        for property in properties.keys():
            val = properties[property]
            res += str(val) + " | "
        res = res[:-2] + "|"
        return res

    @property
    def mimetype(self):
        return "text/markdown"
